Draft WorkingPlaneProxy: Difference between revisions

From FreeCAD Documentation
(Created page with "<translate> {{GuiCommand|Name=Draft SetWorkingPlaneProxy|Workbenches=Draft, Arch|MenuLocation=Draft → Utilities → Create WP Proxy|SeeAlso...")
 
(Button text.)
 
(106 intermediate revisions by 8 users not shown)
Line 1: Line 1:
<languages/>
<translate>
<translate>


<!--T:19-->
{{GuiCommand|Name=Draft SetWorkingPlaneProxy|Workbenches=[[Draft Module|Draft]], [[Arch Module|Arch]]|MenuLocation=Draft → Utilities → Create WP Proxy|SeeAlso=[[Draft SelectPlane]]}}
{{Docnav
|[[Draft_ToggleDisplayMode|ToggleDisplayMode]]
|[[Draft_ApplyStyle|ApplyStyle]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_ToggleDisplayMode.svg
|IconR=Draft_ApplyStyle.svg
|IconC=Workbench_Draft.svg
}}


<!--T:1-->
==Description==
{{GuiCommand
This command will place a Proxy object in the document, placed and aligned to the current [[Draft SelectPlane|Working Plane]]. When using the [[Draft SelectPlane]] command with such a Proxy object selected, the working plane will be positioned and aligned back with the proxy object.
|Name=Draft WorkingPlaneProxy
|MenuLocation=Utilities → Create working plane proxy
|Workbenches=[[Draft_Workbench|Draft]], [[Arch_Workbench|Arch]]
|SeeAlso=[[Draft_SelectPlane|Draft SelectPlane]]
}}


==Description== <!--T:22-->
==How to use==
# Make sure the [[Draft SelectPlane|Working Plane]] is set as you want.
# Press Draft -> Utilities -> {{KEY|[[Image:Draft SetWorkingPlaneProxy.png|16px]] [[Draft SetWorkingPlaneProxy|Create WP Proxy]]}}


<!--T:2-->
==Options==
The [[Image:Draft_WorkingPlaneProxy.svg|24px]] '''Draft WorkingPlaneProxy''' command creates a working plane proxy to save the current [[Draft_SelectPlane|Draft working plane]]. A working plane proxy can be used to quickly restore a working plane. The camera position and visibility of the objects in the [[3D_view|3D view]] are also saved in the working plane proxy and can, [[#Properties|optionally]], be restored as well.
* WP proxies can be manipulated (moved and rotated) like any other FreeCAD object
* The size and appearance of the proxy object can be set in the View properties


</translate>
==Scripting==
[[Image:Draft WPProxy example.png|400px]]
Working plane proxy objects can easily be created in scripts and [[macros]]:
<translate>
<!--T:10-->
{{Caption|Three working plane proxies showing different orientations and offsets}}

==Usage== <!--T:23-->

<!--T:3-->
# Optionally change the [[Draft_SelectPlane|working plane]].
# Optionally change the [[3D_view|3D view]].
# Optionally change the visibility state of objects in the document.
# There are several ways to invoke the command:
#* Press the {{Button|[[Image:Draft_WorkingPlaneProxy.svg|16px]] [[Draft_WorkingPlaneProxy|Create working plane proxy]]}} button.
#* Select the {{MenuCommand|Utilities → [[Image:Draft_WorkingPlaneProxy.svg|16px]] Create working plane proxy}} option from the menu.
# A working plane proxy is created.
# To align the [[Draft_SelectPlane|working plane]] with a working plane proxy, double-click the working plane proxy in the [[Tree_view|Tree view]] or use it with the [[Draft_SelectPlane|Draft SelectPlane]] command.

== Context menu == <!--T:24-->

<!--T:25-->
For a Draft WorkingPlaneProxy these additional options are available in the [[Tree_view|Tree view]] context menu:

<!--T:26-->
* {{MenuCommand|[[Image:Draft_SelectPlane.svg|16px]] Write camera position}}: updates the {{PropertyView|View Data}} property of the working plane proxy with the current [[3D_view|3D view]] camera settings.
* {{MenuCommand|[[Image:Draft_SelectPlane.svg|16px]] Write objects state}}: updates the {{PropertyView|Visibility Map}} property of the working plane proxy with the current visibility state of objects in the document.

==Notes== <!--T:27-->

<!--T:11-->
* Working plane proxies can be [[Draft_Move|moved]] and [[Draft_Rotate|rotated]] like any other object. Use [[Image:Draft_Snap_Center.svg|16px]] [[Draft_Snap_Center|Draft Snap Center]] to snap to their {{PropertyData|Placement}} point.

==Properties== <!--T:7-->

<!--T:28-->
See also: [[Property_editor|Property editor]].

<!--T:29-->
A Draft WorkingPlaneProxy object is derived from an [[App_FeaturePython|App FeaturePython]] object and inherits all its properties. It also has the following additional properties:

=== Data === <!--T:30-->

<!--T:31-->
{{TitleProperty|Base}}

<!--T:8-->
* {{PropertyData|Placement|Placement}}: specifies the position of the working plane proxy in the [[3D_view|3D view]]. See [[Placement|Placement]].
* {{PropertyData|Shape|Shape|Hidden}}: specifies the shape of the working plane proxy.

=== View === <!--T:32-->

<!--T:34-->
{{TitleProperty|Base}}

<!--T:35-->
* {{PropertyView|Line Color|Color}}: specifies the color of all elements of the working plane proxy.
* {{PropertyView|Line Width|Float}}: specifies the line width of the axes and arrow symbols.
* {{PropertyView|Restore State|Bool}}: specifies if the {{PropertyView|Visibility Map}} is restored when the [[Draft_SelectPlane|working plane]] is aligned with the working plane proxy.
* {{PropertyView|Restore View|Bool}}: specifies if the {{PropertyView|View Data}} is restored when the [[Draft_SelectPlane|working plane]] is aligned with the working plane proxy.
* {{PropertyView|Transparency|Percent}}: specifies the transparency of the face of the working plane proxy.
* {{PropertyView|View Data|FloatList}}: specifies the camera position and settings.
* {{PropertyView|Visibility Map|Map|Hidden}}: specifies the visibility state of objects.

<!--T:36-->
{{TitleProperty|Draft}}

<!--T:12-->
* {{PropertyView|Arrow Size|Length}}: specifies the size of the arrow symbols displayed at the tip of the three axes.
* {{PropertyView|Display Size|Length}}: specifies the length and width of the working plane proxy.

==Scripting== <!--T:5-->

<!--T:13-->
See also: [https://freecad.github.io/SourceDoc/ Autogenerated API documentation] and [[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]].

<!--T:14-->
To create a Draft WorkingPlaneProxy use the {{incode|make_workingplaneproxy}} method of the Draft module.

<!--T:15-->
If the [[Draft_Workbench|Draft Workbench]] is active the FreeCAD application object has a {{incode|DraftWorkingPlane}} property which stores the current working plane. The {{Incode|Placement}} from the {{Incode|getPlacement}} method of the {{incode|DraftWorkingPlane}} object can be used to create an aligned working plane proxy. The {{Incode|Placement}} of a working plane proxy in turn can be used to realign the working plane.


Example:
</translate>
</translate>
{{Code|code=
{{Code|code=
# This code only works if the Draft Workbench is active!
import FreeCAD,Draft

currentWP = FreeCAD.DraftWorkingPlane
import FreeCAD as App
Draft.makeWorkingPlaneProxy(currentWP.getPlacement())
import FreeCADGui as Gui
import Draft

doc = App.newDocument()

workplane = App.DraftWorkingPlane
place = workplane.getPlacement()

proxy = Draft.make_workingplaneproxy(place)
proxy.ViewObject.DisplaySize = 3000
proxy.ViewObject.ArrowSize = 200

axis2 = App.Vector(1, 1, 1)
point2 = App.Vector(3000, 0, 0)
place2 = App.Placement(point2, App.Rotation(axis2, 90))

proxy2 = Draft.make_workingplaneproxy(place2)
proxy2.ViewObject.DisplaySize = 3000
proxy2.ViewObject.ArrowSize = 200

workplane.setFromPlacement(proxy2.Placement, rebase=True)
Gui.Snapper.setGrid()

doc.recompute()
}}
}}
<translate>



{{clear}}
<!--T:18-->
<languages/>
{{Docnav
|[[Draft_ToggleDisplayMode|ToggleDisplayMode]]
|[[Draft_ApplyStyle|ApplyStyle]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_ToggleDisplayMode.svg
|IconR=Draft_ApplyStyle.svg
|IconC=Workbench_Draft.svg
}}

</translate>
{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 17:30, 3 December 2023

Draft WorkingPlaneProxy

Menu location
Utilities → Create working plane proxy
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Draft SelectPlane

Description

The Draft WorkingPlaneProxy command creates a working plane proxy to save the current Draft working plane. A working plane proxy can be used to quickly restore a working plane. The camera position and visibility of the objects in the 3D view are also saved in the working plane proxy and can, optionally, be restored as well.

Three working plane proxies showing different orientations and offsets

Usage

  1. Optionally change the working plane.
  2. Optionally change the 3D view.
  3. Optionally change the visibility state of objects in the document.
  4. There are several ways to invoke the command:
  5. A working plane proxy is created.
  6. To align the working plane with a working plane proxy, double-click the working plane proxy in the Tree view or use it with the Draft SelectPlane command.

Context menu

For a Draft WorkingPlaneProxy these additional options are available in the Tree view context menu:

  • Write camera position: updates the ViewView Data property of the working plane proxy with the current 3D view camera settings.
  • Write objects state: updates the ViewVisibility Map property of the working plane proxy with the current visibility state of objects in the document.

Notes

Properties

See also: Property editor.

A Draft WorkingPlaneProxy object is derived from an App FeaturePython object and inherits all its properties. It also has the following additional properties:

Data

Base

  • DataPlacement (Placement): specifies the position of the working plane proxy in the 3D view. See Placement.
  • Data (Hidden)Shape (Shape): specifies the shape of the working plane proxy.

View

Base

  • ViewLine Color (Color): specifies the color of all elements of the working plane proxy.
  • ViewLine Width (Float): specifies the line width of the axes and arrow symbols.
  • ViewRestore State (Bool): specifies if the ViewVisibility Map is restored when the working plane is aligned with the working plane proxy.
  • ViewRestore View (Bool): specifies if the ViewView Data is restored when the working plane is aligned with the working plane proxy.
  • ViewTransparency (Percent): specifies the transparency of the face of the working plane proxy.
  • ViewView Data (FloatList): specifies the camera position and settings.
  • View (Hidden)Visibility Map (Map): specifies the visibility state of objects.

Draft

  • ViewArrow Size (Length): specifies the size of the arrow symbols displayed at the tip of the three axes.
  • ViewDisplay Size (Length): specifies the length and width of the working plane proxy.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a Draft WorkingPlaneProxy use the make_workingplaneproxy method of the Draft module.

If the Draft Workbench is active the FreeCAD application object has a DraftWorkingPlane property which stores the current working plane. The Placement from the getPlacement method of the DraftWorkingPlane object can be used to create an aligned working plane proxy. The Placement of a working plane proxy in turn can be used to realign the working plane.

# This code only works if the Draft Workbench is active!

import FreeCAD as App
import FreeCADGui as Gui
import Draft

doc = App.newDocument()

workplane = App.DraftWorkingPlane
place = workplane.getPlacement()

proxy = Draft.make_workingplaneproxy(place)
proxy.ViewObject.DisplaySize = 3000
proxy.ViewObject.ArrowSize = 200

axis2 = App.Vector(1, 1, 1)
point2 = App.Vector(3000, 0, 0)
place2 = App.Placement(point2, App.Rotation(axis2, 90))

proxy2 = Draft.make_workingplaneproxy(place2)
proxy2.ViewObject.DisplaySize = 3000
proxy2.ViewObject.ArrowSize = 200

workplane.setFromPlacement(proxy2.Placement, rebase=True)
Gui.Snapper.setGrid()

doc.recompute()